
# OdinOnDemand

OdinOnDemand introduces various multimedia elements to the game, enabling players to natively view YouTube videos and direct video files on in-game screens. The mod also offers a boombox/gramophone that can play audio files and SoundCloud links -- additionally, this mod is multiplayer-compatible and appears to have a low performance impact.

ValMedia recommends playing without bloom while watching for the best viewing experience. 

0.9.75 includes a large UI redesign with new buttons and sliders, ward locking, and more vanilla-like piece behavior. Check the changelog for more info! Destroy with hammer to refund materials. 



[<img alt="Preview Video" width="256px" src="https://i.imgur.com/0BaY28I.jpg" />](https://www.youtube.com/watch?v=hePW1dueKjE)



## Features

- Cinema screens
   - Flatscreen TV, Table TV, Monitor, Old TV, Laptop
   - Can play YouTube, Remote and Local files
- Audio Players
   - Gramophone, Boombox
   - Can play SoundCloud, YouTube, Remote and Local files
- Youtube playlist support
- Remote control to use screens from a distance
- Multiplayer functionality
- Audio Control <sub>(Client Side)</sub>
- Forward Tracking <sub>(Client Side)</sub>
- Looping
- Piece Recipe Configuration (item recipes coming soon)

This mod is in beta and has not been extensively tested. Please report any issues on
the Nexus or GitHub tracker.

## Installation

Installation of the plugin is fairly straightforward, just install into Bepinex/plugins or use r2modman. It must be installed on both server and client.

## Recipes

Recipes can now be tweaked through a json file located at BepInEx\config\com.ood.valmedia.recipes.json, the mod will automatically make this. However the default recipe file can be found [here](https://github.com/modestimpala/OdinOnDemand/blob/main/com.ood.valmedia.recipes.json) if needed. 

Some helpful links to help you edit this file are here

[Beautify JSON to made it readable, and validate it here](https://codebeautify.org/jsonviewer)

[Valheim Item List](https://valheim-modding.github.io/Jotunn/data/objects/item-list.html)

Unless you know what you're doing, please only change the requirements section. If you have any issues keep in mind you can delete your .json file and the mod will re-create it with default values.

The remote control recipe can't be tweaked yet, you can always use a mod like WackysDB for the time being.

## Use
In game, place down a cinema screen or boombox. Media-players can be destroyed with the hammer or with damage to get materials back.

Interact with it to open the GUI.

For cinema screens, you must have
either a direct link to a remote or local video file of a 
[compatible codec](https://docs.unity3d.com/2020.1/Documentation/Manual/VideoSources-FileCompatibility.html)
or use a youtube/youtu.be link. YouTube should work natively. There is an optional self-hosted backup API, if interested check GitHub.

For boomboxes, you must have a direct link to a remote or local audio file of a 
[compatible codec](https://support.unity.com/hc/en-us/articles/206484803-What-are-the-supported-Audio-formats-in-Unity-), a soundcloud.com link, or a youtube/youtu.be link. Through testing I've noticed some SoundCloud songs are 
unavailable. I think it depends on the artist and how they upload/license their art. 

Local files are not synced over multiplayer.

Put the link into the input field and click set to set a file. Control playback
with play, pause, and stop. 
Control individual player's volume with the slider and mute button.
">>" to track forward. There are also loop and shuffle toggles.

You can play YouTube playlists - when a playlist is set, new info will appear. You can choose to shuffle or loop the playlist. 
If you turn on looping while a playlist is active, the whole playlist will loop - not individual videos. The Viking who sets the playlist handles playlist logic, so if they leave the area or disconnect playlist playback will stop, but it is multiplayer synced. Try not to skip through tracks too fast.

Media-players can be controlled from a distance with a remote control. A remote control can be crafted with 1 bronze. Simply equip, point at a media-player and click.
Config options include max controller distance, and an option to make remote control access private. 

Media-players can be locked in the top right corner of the menu. When a media-player is locked, Vikings can only access it if they have access to the private area created by a Ward. This may have to be toggled again for Vikings who load in after unlocking.

In the mod settings you can control master volume. This will affect every screen/boombox.

All set file/play/pause/stop/looping commands should be synced for multiplayer through RPC events. 
Volume and tracking are client sided. Tracking will de-sync. 
Screens do not currently check for sync or update to currently playing videos when connecting/loading new media-players.

## Known Issues

If you have V-Sync force enabled in your GPU driver control panel, the mod may not function. 

![V-Sync Screenshot](https://i.imgur.com/JZTG3CZ.png)

If the mod fails to play any sort of video file, not just YouTube, check your Player.log. If there are errors about Direct3D and refresh rate / v-sync you may have to do this. Please check your GPU driver's control panel and make sure the vertical sync setting is either identical your in-game settings or set to "match application setting"

## Screenshots 
![Mod Screenshot](https://cdn.discordapp.com/attachments/602048405702705173/1076343490625151078/valheim_pqt3uMxRgR.png)
![Mod Screenshot](https://i.imgur.com/IOYPOAa.jpeg)
![Mod Screenshot](https://i.imgur.com/QL6gvwc.jpg)
![Mod Screenshot](https://i.imgur.com/Y88KuWV.jpg)
![Mod Screenshot](https://i.imgur.com/wTmD6Cc.jpeg)
<sub>[Build by DanAugust](https://www.valheimians.com/build/small-simple-cabin-pre-plains/) Last picture is with back-light setting turned off.</sub>

For any tech-savvy Vikings out there, there is a backup YouTube api that can be self hosted using Node and youtube-dl. This is **completely optional** and not required as long as the built in library is maintained (YouTubeExplode)

[Tutorial Video](https://www.youtube.com/watch?v=9_vs8MItO38)

[Github Instructions](https://github.com/modestimpala/OdinOnDemand)

## Acknowledgements

 - [SoundCloudExplode](https://github.com/jerry08/SoundCloudExplode) | [YouTubeExplode](https://github.com/Tyrrrz/YoutubeExplode) | [youtube-exec-dl](https://www.npmjs.com/package/youtube-dl-exec) | [nodejs](https://nodejs.org/en/) | [yt-dlp](https://github.com/yt-dlp/yt-dlp)
 - Inspired by [Raft Cinema Mod](https://www.raftmodding.com/mods/cinema-mod)
